# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.datasource_type import DatasourceType  # noqa: F401,E501
from swagger_server import util


class Datasource(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, datasource_type: DatasourceType=None):  # noqa: E501
        """Datasource - a model defined in Swagger

        :param datasource_type: The datasource_type of this Datasource.  # noqa: E501
        :type datasource_type: DatasourceType
        """
        self.swagger_types = {
            'datasource_type': DatasourceType
        }

        self.attribute_map = {
            'datasource_type': 'datasource-type'
        }
        self._datasource_type = datasource_type

    @classmethod
    def from_dict(cls, dikt) -> 'Datasource':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The datasource of this Datasource.  # noqa: E501
        :rtype: Datasource
        """
        return util.deserialize_model(dikt, cls)

    @property
    def datasource_type(self) -> DatasourceType:
        """Gets the datasource_type of this Datasource.


        :return: The datasource_type of this Datasource.
        :rtype: DatasourceType
        """
        return self._datasource_type

    @datasource_type.setter
    def datasource_type(self, datasource_type: DatasourceType):
        """Sets the datasource_type of this Datasource.


        :param datasource_type: The datasource_type of this Datasource.
        :type datasource_type: DatasourceType
        """

        self._datasource_type = datasource_type
